// Generated by CoffeeScript 1.9.1
var exec, fs, path;

exec = require('executive');

fs = require('fs');

path = require('path');

module.exports = {
  mappings: {
    coffee: 'js',
    jade: 'html',
    styl: 'css'
  },
  compile: function(filename, cb) {
    var c, cmd, cmds, compiler, dst, ext, src;
    ext = (path.extname(filename)).substr(1);
    if ((compiler = this[ext]) == null) {
      return cb(null, false);
    }
    src = filename;
    dst = filename.replace(new RegExp(ext + '$'), this.mappings[ext]);
    if (compiler.length === 3) {
      return compiler(src, dst, cb);
    }
    cmd = compiler(src, dst);
    if (typeof cmd !== 'string') {
      return cb(null, false);
    }
    cmds = (function() {
      var i, len, ref, results;
      ref = cmd.split(';');
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        c = ref[i];
        if ((c != null) && c.trim() !== '') {
          results.push(c.trim());
        }
      }
      return results;
    })();
    return exec.quiet(cmds, function(err, stdout, stderr) {
      if (err != null) {
        return cb(err);
      }
      if ((stderr != null) && stderr.trim() !== '') {
        return cb(new Error(stderr));
      }
      return cb(null, true);
    });
  },
  coffee: function(src, dst) {
    dst = path.dirname(dst);
    return "coffee -bmc -o " + dst + " " + src;
  },
  jade: function(src, dst) {
    dst = path.dirname(dst);
    return "jade --pretty " + src + " --out " + dst;
  },
  styl: function(src, dst) {
    dst = path.dirname(dst);
    return "stylus " + src + " -o " + dst;
  }
};

//# sourceMappingURL=compilers.js.map
